using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Net.Sockets;
using System.Net;
using System.Xml;
using System.Xml.Serialization;
using System.Xml.Schema;

namespace UHF_Demo
{
    public partial class Engorde : Form
    {
        ComPort Port0 = new ComPort();
        string s0 = "";     
        byte[,] TagBuf = new byte[100, 14];
        bool flagsave;
        int tagindex = 0;     //ARRAY INDEX
        string[] tags = new string[1];       //TAGs ARRAY
        string[] tags2;     //aux array
        bool flagxml = false;
        string fName;
        string EPCcode;
        string tf;
        string dirarchiv;

        public Engorde()
        {
            InitializeComponent();
        }

        private void Ant0_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void Pri0_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void Sig0_Click(object sender, EventArgs e)
        {
            tabControl1.SelectedIndex = tabControl1.TabPages.IndexOf(tabPage2);
        }

        private void Ant1_Click(object sender, EventArgs e)
        {
            tabControl1.SelectedIndex = tabControl1.TabPages.IndexOf(tabPage1);
        }

        private void Pri1_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void Sig1_Click(object sender, EventArgs e)
        {
            tabControl1.SelectedIndex = tabControl1.TabPages.IndexOf(tabPage3);
        }

        private void Ant2_Click(object sender, EventArgs e)
        {
            tabControl1.SelectedIndex = tabControl1.TabPages.IndexOf(tabPage2);
        }

        private void Pri2_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void Sig2_Click(object sender, EventArgs e)
        {
            tabControl1.SelectedIndex = tabControl1.TabPages.IndexOf(tabPage4);
        }

        private void Ant3_Click(object sender, EventArgs e)
        {
            tabControl1.SelectedIndex = tabControl1.TabPages.IndexOf(tabPage3);
        }

        private void Pri3_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void Leer_Click(object sender, EventArgs e)
        {
            Port0.ClearIdBuf();     //limpia el buffer de lectura de tags
            tagleidos.Text = "Puerto abierto";
            Port0.Open();           //abre el puerto
            tagleidos.Text = "Timer activado";
            this.timer1.Enabled = true;  //inicia el timer de lectura
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            byte tag_cnt = 0;
            string s1 = "";
            byte TagFlag = 0;
            flagsave = false;

            if (Port0.Opened == true)   //comprueba que este abierto el puerto
            {


                if (Port0.EpcMultiTagIdentify(ref TagBuf, ref tag_cnt, ref TagFlag) == 0)   //si devuelve 0 se habra identificado algun tag
                {
                    tagleidos.Text = "Leyendo";
                    //                    MessageBox.Show(Convert.ToString(tag_cnt));
                    if ((tag_cnt > 0) && (tag_cnt < 200))
                    {
                        for (int TagIndex = 0; TagIndex < tag_cnt; TagIndex++)
                        {
                            s0 = ""; //string.Format("No.{0:D}:", TagCnt + i);
                            for (int CodeIndex = 0; CodeIndex < 12; CodeIndex++)
                            {
                                s1 = string.Format("{0:X2} ", TagBuf[TagIndex, CodeIndex]);
                                s0 += s1;
                            }
                        }

                        for (int i = 0; i < tags.Length; i++)     //checking existence of s0 in tags array
                        {
                            if (tags[i] == s0)
                                flagsave = true;
                        }
                        if (flagsave == false)
                        {
                            Sound.PlayWAV(@"\Application Data\Rfid\wav\shutter.wav");

                            tagindex++;
                            if (tagindex == 1)
                            {
                                tags[0] = s0;
                            }
                            else
                            {
                                tags2 = new string[tagindex];
                                tags.CopyTo(tags2, 0);
                                tags = null;
                                tags2[tagindex - 1] = s0;
                                tags = new string[tagindex];
                                tags2.CopyTo(tags, 0);
                                tags2 = null;

                            }
                            tagleidos.Enabled = true;      //rutina de presentar datos, cerrar el puerto y terminar el timer
                            tagleidos.Text = tags.Length.ToString() + " tags identificados";
                            tagleidos.Enabled = false;
                            Port0.Close();
                            this.timer1.Enabled = false;
                        }



                    }
                }
                else
                {
                    tagleidos.Text = tags.Length.ToString() + " tags identificados";
                    Port0.Close();
                    this.timer1.Enabled = false;

                }

            }
        }

        private void Enviar_Click(object sender, EventArgs e)
        {
                        ///XML FILE GEN.
            try
            {
                if (flagxml == false)
                {
                    

                    EPCcode = genEPCcode();
                    tf = checkfish();
                    

                    dirarchiv = @"\My Documents\capturas\" + "ENG_" + DateTime.Now.ToString("ddMMyyHHmm") + ".xml";
                    XmlDocument xdoc = new XmlDocument();

                    XmlDeclaration xdec = xdoc.CreateXmlDeclaration("1.0", "UTF-8", "no");
                    xdoc.AppendChild(xdec);

                    XmlElement xroot = xdoc.CreateElement("epcis", "EPCISDocument", "EPCISDocument");
                    xdoc.AppendChild(xroot);
                    xroot.SetAttribute("xmlns:epcis", "urn:epcglobal:epcis:xsd:1");
                    xroot.SetAttribute("xmlns:xsi", "http://www.w3.org/2001/XMLSchema-instance");
                    xroot.SetAttribute("creationDate", DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss.fffzzzz"));
                    xroot.SetAttribute("schemaVersion", "1.0");

                    XmlElement xn1 = xdoc.CreateElement("EPCISBody");
                    xroot.AppendChild(xn1);

                    XmlElement xn2 = xdoc.CreateElement("EventList");
                    xn1.AppendChild(xn2);

                    XmlElement xn3 = xdoc.CreateElement("ObjectEvent");
                    xn2.AppendChild(xn3);

                    //Append to AGevent (xn3);
                    XmlElement xn4 = xdoc.CreateElement("eventTime");
                    xn3.AppendChild(xn4);
                    XmlText xn4T = xdoc.CreateTextNode(DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ssZ"));
                    xn4.AppendChild(xn4T);

                    XmlElement xn5 = xdoc.CreateElement("eventTimeZoneOffset");
                    xn3.AppendChild(xn5);
                    XmlText xn5T = xdoc.CreateTextNode(DateTime.Now.ToString("zzzz"));
                    xn5.AppendChild(xn5T);

                    XmlElement xn6 = xdoc.CreateElement("epcList");
                    xn3.AppendChild(xn6);
                    XmlElement xn6i = xdoc.CreateElement("epc");
                    xn6.AppendChild(xn6i);
                    XmlText xn6T = xdoc.CreateTextNode("http://wmrfid.org/farm2fork/2000005/product/" + tf + "/" + EPCcode);
                    xn6i.AppendChild(xn6T);

                    XmlElement xn22 = xdoc.CreateElement("action");
                    xn3.AppendChild(xn22);
                    XmlText xn22T = xdoc.CreateTextNode("ADD");
                    xn22.AppendChild(xn22T);

                    XmlElement xn23 = xdoc.CreateElement("bizStep");
                    xn3.AppendChild(xn23);
                    XmlText xn23T = xdoc.CreateTextNode("http://wmrfid.org/farm2fork/2000005/bizstep/commissioning");
                    xn23.AppendChild(xn23T);

                    XmlElement xn24 = xdoc.CreateElement("disposition");
                    xn3.AppendChild(xn24);
                    XmlText xn24T = xdoc.CreateTextNode("http://wmrfid.org/farm2fork/2000005/disposition/active");
                    xn24.AppendChild(xn24T);

                    XmlElement xn25 = xdoc.CreateElement("readPoint");
                    xn3.AppendChild(xn25);
                    XmlElement xn26 = xdoc.CreateElement("id");
                    xn25.AppendChild(xn26);
                    XmlText xn26T = xdoc.CreateTextNode("http://wmrfid.org/farm2fork/2000005/location/0000030401");   //30401 Sea Cages Reader ---> only one device now
                    xn26.AppendChild(xn26T);

                    XmlElement xn27 = xdoc.CreateElement("bizLocation"); // Tag fixed on the cage
                    xn3.AppendChild(xn27);
                    XmlElement xn28 = xdoc.CreateElement("id");
                    xn27.AppendChild(xn28);
                    XmlText xn28T = xdoc.CreateTextNode(Hex2urn(tags[0])); 
                    xn28.AppendChild(xn28T);




                    xdoc.Save(dirarchiv);       // saving first event file



                    fName = "ENG_" + DateTime.Now.ToString("ddMMyyHHmm") + ".xml";
                    flagxml = true;
                }
            }

            catch
            {
                MessageBox.Show("Error al generar el archivo", "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1);
            }
            try //SEND
            {
                string urlString = "http://" + IPenvio.Text + ":8080/epcis-repository-0.5.0/capture";
                HttpWebRequest req = (HttpWebRequest)WebRequest.Create(urlString);

                req.Method = "POST";

                req.AllowWriteStreamBuffering = true;

                // Retrieve request stream and wrap in StreamWriter

                Stream reqStream = req.GetRequestStream();

                StreamWriter wrtr = new StreamWriter(reqStream);



                // Open the local file

                StreamReader rdr = new StreamReader(dirarchiv);

                // loop through the local file reading each line 

                //  and writing to the request stream buffer

                string inLine = rdr.ReadLine();

                while (inLine != null)
                {

                    wrtr.WriteLine(inLine);

                    inLine = rdr.ReadLine();

                }

                rdr.Close();

                wrtr.Close();

                //Comment if you want to keep XML file on mobile

                //File.Delete((System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().GetName().CodeBase)) + "xml.xml");

                req.GetResponse();

                MessageBox.Show("Enviado correctamente", "OK", MessageBoxButtons.OK, MessageBoxIcon.None, MessageBoxDefaultButton.Button1);
            }

            catch (Exception ex)
            {
                MessageBox.Show("Error al enviar el archivo", "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1);
                const string fic = @"\My Documents\capturas\LOGPruebas.txt";
                System.IO.StreamWriter sw = new System.IO.StreamWriter(fic);
                sw.WriteLine(DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss.ffzzzz") + " --> " + ex.Message);
                sw.Close();
            }
        }

        string checkfish()
        {
            string ft = "";
            switch (tipopez.Text)
            {
                case "Lubina":
                    ft = "000003";
                    break;
                case "Dorada":
                    ft = "000002";
                    break;
            }

            return ft;
        }

        string genEPCcode()
        {

            // FOLLOWING V5 SPEC TABLE

            return Loteorigen.Text.PadLeft(4, '0') + Lotegranja.Text.PadLeft(4, '0');


        }

        //EPC-->URN  ####MODIFIED TO SATISFY THIS TAB####
        private string Hex2urn(string sHexvalue)
        {
            string sValue = null;
            string sTemp;
            string sUrn = "";
            char[] caValue = new char[sHexvalue.Length - 1];

            // REMOVING " " STRING TAGS

            string taux = "";

            for (int i = 0; i < 12; i++)
            {
                taux = taux + sHexvalue.Substring(3 * i, 2);
            }

            ///////////////////////////////////////////



            caValue = taux.ToCharArray();

            foreach (char a in caValue)
            {
                sTemp = Convert.ToString(Convert.ToInt32(a.ToString(), 16), 2);
                sTemp = sTemp.PadLeft(4, '0');
                sUrn = sUrn + sTemp;
            }
            //for SGTIN
            if (sUrn.StartsWith("00110000"))
            {
                int[] c = GetPartition(sUrn.Substring(11, 3));
                long lFilter = Convert.ToInt64(sUrn.Substring(8, 3), 2);
                long lCompany = Convert.ToInt64(sUrn.Substring(14, c[0]), 2);
                //long lCompany = 2000005;
                long lObject = Convert.ToInt64(sUrn.Substring(14 + c[0], c[1]), 2);
                long lSerial = Convert.ToInt64(sUrn.Substring(58), 2);
                sValue = "http://wmrfid.org/farm2fork/" + Convert.ToString(lCompany) + "/product/" + Convert.ToString(lObject).PadLeft(6, '0') + "/" + Convert.ToString(lSerial);
            }
            //GRAI
            else if (sUrn.StartsWith("00110011"))
            {
                int[] c = GetPartition(sUrn.Substring(11, 3));
                long lFilter = Convert.ToInt64(sUrn.Substring(8, 3), 2);
                long lCompany = Convert.ToInt64(sUrn.Substring(14, c[0]), 2);
                // long lCompany = 2000005;
                long lAsset = Convert.ToInt64(sUrn.Substring(14 + c[0], c[1]), 2);
                long lSerial = Convert.ToInt64(sUrn.Substring(58), 2);
                sValue = "http://wmrfid.org/farm2fork/" + Convert.ToString(lCompany) + "/asset/" + Convert.ToString(lAsset).PadLeft(5, '0') + "/" + Convert.ToString(lSerial);

            }
            //for GID
            //else
            //{
            //    long lCompany = Convert.ToInt64(sUrn.Substring(8, 28), 2);
            //    long lObject = Convert.ToInt64(sUrn.Substring(36, 24), 2);
            //    long lSerial = Convert.ToInt64(sUrn.Substring(60), 2);
            //    string sValue = "urn:epc:id:gid:" + Convert.ToString(lCompany) + "." + Convert.ToString(lObject) + "." + Convert.ToString(lSerial);
            //    return sValue;

            //}
            //SGLN
            else if (sUrn.StartsWith("00110010"))
            {
                int[] c = GetPartition(sUrn.Substring(11, 3));
                long lFilter = Convert.ToInt64(sUrn.Substring(8, 3), 2);
                long lCompany = Convert.ToInt64(sUrn.Substring(14, c[0]), 2);
                // long lCompany = 2000005;
                long lLocation = Convert.ToInt64(sUrn.Substring(14 + c[0], c[1]), 2);
                long lExtension = Convert.ToInt64(sUrn.Substring(58), 2);
                sValue = "http://wmrfid.org/farm2fork/" + Convert.ToString(lCompany) + "/location/" + Convert.ToString(lLocation).PadLeft(5, '0') + "/" + Convert.ToString(lExtension);

            }
            return sValue;
        }

        private int[] GetPartition(string sPartition)
        {
            int[] iaPartitionIndex = new int[2];
            if (sPartition.Equals("000"))
            {
                iaPartitionIndex[0] = 40; iaPartitionIndex[1] = 4;
            }
            else if (sPartition.Equals("001"))
            {
                iaPartitionIndex[0] = 37; iaPartitionIndex[1] = 7;
            }
            else if (sPartition.Equals("010"))
            {
                iaPartitionIndex[0] = 34; iaPartitionIndex[1] = 10;
            }
            else if (sPartition.Equals("011"))
            {
                iaPartitionIndex[0] = 30; iaPartitionIndex[1] = 14;
            }
            else if (sPartition.Equals("100"))
            {
                iaPartitionIndex[0] = 27; iaPartitionIndex[1] = 17;
            }
            else if (sPartition.Equals("101"))
            {
                iaPartitionIndex[0] = 24; iaPartitionIndex[1] = 20;
            }
            else
            {
                iaPartitionIndex[0] = 20; iaPartitionIndex[1] = 24;
            }

            return iaPartitionIndex;
        }

        private void Escribir_Click(object sender, EventArgs e)
        {
            string tmpStr = checkfish().Substring(4, 2) + EPCcode + "00";    // Only takes the crucial digits 02 o 03 depending on the type of fish
            byte[] value = new byte[6];                                      // Type of fish + BatchID + Batch moving number ---> 12 digitos

            for (int j = 0; j == 5; j++)
            {
                value[j] = Convert.ToByte(tmpStr.Substring(j * 2, 2), 10);
            }
            int status = Port0.EpcBlockWrite(0, 0, ref value, 3);

            if (status == 0)
            {
                MessageBox.Show("Write success", "OK", MessageBoxButtons.OK, MessageBoxIcon.Hand, MessageBoxDefaultButton.Button1);
            }
            else
            {
                MessageBox.Show("Write error", "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1);
            }
        }
    }
}