using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Net.Sockets;
using System.Net;
using System.Xml;
using System.Xml.Serialization;
using System.Xml.Schema;

namespace UHF_Demo
{
    public partial class Envio : Form
    {
        ComPort Port0 = new ComPort();
        byte[,] TagBuf = new byte[100, 14];
        string[] tags = new string[1];       //TAGs ARRAY
        bool flagxml = false;
        string fName;
        string dirarchiv;


        public Envio()
        {
            InitializeComponent();
        }

        private void Ant0_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void Pri0_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void Sig0_Click(object sender, EventArgs e)
        {
            tabControl1.SelectedIndex = tabControl1.TabPages.IndexOf(tabPage2);
        }

        private void Ant1_Click(object sender, EventArgs e)
        {
            tabControl1.SelectedIndex = tabControl1.TabPages.IndexOf(tabPage1);
        }

        private void Pri1_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void Sig1_Click(object sender, EventArgs e)
        {
            tabControl1.SelectedIndex = tabControl1.TabPages.IndexOf(tabPage3);
        }

        private void Ant2_Click(object sender, EventArgs e)
        {
            tabControl1.SelectedIndex = tabControl1.TabPages.IndexOf(tabPage2);
        }

        private void Pri2_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void Enviar_Click(object sender, EventArgs e)
        {
            if (flagxml == false)
            {



                try
                {

                    dirarchiv = @"\My Documents\capturas\" + "ENV_" + DateTime.Now.ToString("ddMMyyHHmm") + ".xml";
                    XmlDocument xdoc = new XmlDocument();

                    XmlDeclaration xdec = xdoc.CreateXmlDeclaration("1.0", "UTF-8", "no");
                    xdoc.AppendChild(xdec);

                    XmlElement xroot = xdoc.CreateElement("epcis", "EPCISDocument", "EPCISDocument");
                    xdoc.AppendChild(xroot);
                    xroot.SetAttribute("xmlns:epcis", "urn:epcglobal:epcis:xsd:1");
                    xroot.SetAttribute("xmlns:xsi", "http://www.w3.org/2001/XMLSchema-instance");
                    xroot.SetAttribute("creationDate", DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss.fffzzzz"));
                    xroot.SetAttribute("schemaVersion", "1.0");

                    XmlElement xn1 = xdoc.CreateElement("EPCISBody");
                    xroot.AppendChild(xn1);

                    XmlElement xn2 = xdoc.CreateElement("EventList");
                    xn1.AppendChild(xn2);
                    XmlElement xn16 = xdoc.CreateElement("AggregationEvent");
                    xn2.AppendChild(xn16);

                    //Append to AGevent (xn16);
                    XmlElement xn17 = xdoc.CreateElement("eventTime");
                    xn16.AppendChild(xn17);
                    XmlText xn17T = xdoc.CreateTextNode(DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ssZ"));
                    xn17.AppendChild(xn17T);

                    XmlElement xn18 = xdoc.CreateElement("eventTimeZoneOffset");
                    xn16.AppendChild(xn18);
                    XmlText xn18T = xdoc.CreateTextNode(DateTime.Now.ToString("zzzz"));
                    xn18.AppendChild(xn18T);

                    XmlElement xn19 = xdoc.CreateElement("parentID");
                    xn16.AppendChild(xn19);
                    XmlText xn19T = xdoc.CreateTextNode("http://wmrfid.org/farm2fork/2000005/asset/00001/"+Matricula.Text);
                    xn19.AppendChild(xn19T);

                    XmlElement xn20 = xdoc.CreateElement("childEPCs");
                    xn16.AppendChild(xn20);
                    XmlElement xn21 = xdoc.CreateElement("epc");
                    xn20.AppendChild(xn21);
                    XmlText xn21T = xdoc.CreateTextNode("HARVID"); //HARVID escogida del textbox
                    xn21.AppendChild(xn21T);




                    XmlElement xn22 = xdoc.CreateElement("action");
                    xn16.AppendChild(xn22);
                    XmlText xn22T = xdoc.CreateTextNode("ADD");
                    xn22.AppendChild(xn22T);

                    XmlElement xn23 = xdoc.CreateElement("bizStep");
                    xn16.AppendChild(xn23);
                    XmlText xn23T = xdoc.CreateTextNode("http://wmrfid.org/farm2fork/2000005/bizstep/departing");
                    xn23.AppendChild(xn23T);

                    XmlElement xn24 = xdoc.CreateElement("disposition");
                    xn16.AppendChild(xn24);
                    XmlText xn24T = xdoc.CreateTextNode("http://wmrfid.org/farm2fork/2000005/disposition/in_transit");
                    xn24.AppendChild(xn24T);

                    XmlElement xn25 = xdoc.CreateElement("readPoint");
                    xn16.AppendChild(xn25);
                    XmlElement xn26 = xdoc.CreateElement("id");
                    xn25.AppendChild(xn26);
                    XmlText xn26T = xdoc.CreateTextNode("http://wmrfid.org/farm2fork/2000005/location/0000030401");
                    xn26.AppendChild(xn26T);

                    XmlElement xn27 = xdoc.CreateElement("bizLocation");
                    xn16.AppendChild(xn27);
                    XmlElement xn28 = xdoc.CreateElement("id");
                    xn27.AppendChild(xn28);
                    XmlText xn28T = xdoc.CreateTextNode("http://wmrfid.org/farm2fork/2000005/location/0000030300");
                    xn28.AppendChild(xn28T);

                    xdoc.Save(dirarchiv);
                }

                catch (Exception ex)
                {
                    MessageBox.Show("Error al crear el archivo", "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1);
                    const string fic = @"\My Documents\capturas\LOGPruebasEMP.txt";
                    System.IO.StreamWriter sw = new System.IO.StreamWriter(fic);
                    sw.WriteLine(DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss.ffzzzz") + " --> " + ex.Message);
                    //sw.WriteLine(sdTemp + " tag HEX: " + tags[0]+ " dlength: "+dlength);
                    sw.Close();
                }

                fName = "ENV_" + DateTime.Now.ToString("ddMMyyHHmm") + ".xml";
                flagxml = true;
            }



            try //SEND
            {



                // POSTING ROUTINE //




                string urlString = "http://" + IPenvio.Text + ":8080/epcis-repository-0.5.0/capture";
                HttpWebRequest req = (HttpWebRequest)WebRequest.Create(urlString);

                req.Method = "POST";

                req.AllowWriteStreamBuffering = true;

                // Retrieve request stream and wrap in StreamWriter

                Stream reqStream = req.GetRequestStream();

                StreamWriter wrtr = new StreamWriter(reqStream);


                // Open the local file

                StreamReader rdr = new StreamReader(dirarchiv);

                // loop through the local file reading each line 

                //  and writing to the request stream buffer

                string inLine = rdr.ReadLine();

                while (inLine != null)
                {

                    wrtr.WriteLine(inLine);

                    inLine = rdr.ReadLine();

                }

                rdr.Close();

                wrtr.Close();

                //Comment if you want to keep XML file on mobile

                //File.Delete((System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().GetName().CodeBase)) + "xml.xml");

                req.GetResponse();




                MessageBox.Show("Enviado correctamente", "OK", MessageBoxButtons.OK, MessageBoxIcon.None, MessageBoxDefaultButton.Button1);
            }

            catch (Exception ex)
            {
                MessageBox.Show("Error al enviar el archivo", "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1);
                const string fic = @"\My Documents\capturas\LOGPruebas.txt";
                System.IO.StreamWriter sw = new System.IO.StreamWriter(fic);
                sw.WriteLine(DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss.ffzzzz") + " --> " + ex.Message);
                sw.Close();
            }
        }


    }
}