using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Net.Sockets;
using System.Net;
using System.Xml;
using System.Xml.Serialization;
using System.Xml.Schema;

namespace UHF_Demo
{
    public partial class Pesca : Form
    {
        ComPort Port0 = new ComPort();
        string s0 = "";
        byte[,] TagBuf = new byte[100, 14];
        bool flagsave;
        int tagindex = 0;     //ARRAY INDEX
        string[] tags = new string[1];       //TAGs ARRAY
        string[] tags2;     //aux array
        bool flagxml = false;
        string fName;
        string EPCcode;
        string tf;
        string dirarchiv;
        string dirclass;
        string tagdata;
        Orden pesc;

        public Pesca()
        {
            InitializeComponent();
        }

        private void Ant0_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void Pri0_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void Sig0_Click(object sender, EventArgs e)
        {
            tabControl1.SelectedIndex = tabControl1.TabPages.IndexOf(tabPage2);
        }

        private void Ant1_Click(object sender, EventArgs e)
        {
            tabControl1.SelectedIndex = tabControl1.TabPages.IndexOf(tabPage1);
        }

        private void Pri1_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void Sig1_Click(object sender, EventArgs e)
        {
            tabControl1.SelectedIndex = tabControl1.TabPages.IndexOf(tabPage3);
        }

        private void Ant2_Click(object sender, EventArgs e)
        {
            tabControl1.SelectedIndex = tabControl1.TabPages.IndexOf(tabPage2);
        }

        private void Pri2_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            int status;
            byte[] value = new byte[6];
            byte membank = (byte)(3);
            byte wordptr = (byte)(0);
            byte wordcnt = (byte)(3);

            string s2 = "";

            status = Port0.EpcRead(membank, wordptr, wordcnt, ref value);
            if (status == 0)
            {
                for (int i = 0; i < wordcnt * 2; i++)
                {
                    s2 = string.Format("{0:X2} ", value[i]);
                    tagdata += s2;
                }
                MessageBox.Show("Lectura correcta", "OK", MessageBoxButtons.OK, MessageBoxIcon.Hand, MessageBoxDefaultButton.Button1);
                LecTagComercial.Text = "1 tag ledo";
            }
            else
            {
                MessageBox.Show("Error de lectura", "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1);
            }
        }

        private void Enviar_Click(object sender, EventArgs e)
        {
            ///XML FILE GEN.
            try
            {
                if (flagxml == false)
                {

                    EPCcode = genEPCcode();
                    pesc= new Orden(genEPCcode());
                    tf = checkfish(tagdata.Substring(0, 2));

                    dirarchiv = @"\My Documents\capturas\" + "PES_" + DateTime.Now.ToString("ddMMyyHHmm") + ".xml";
                    XmlDocument xdoc = new XmlDocument();

                    XmlDeclaration xdec = xdoc.CreateXmlDeclaration("1.0", "UTF-8", "no");
                    xdoc.AppendChild(xdec);

                    XmlElement xroot = xdoc.CreateElement("epcis", "EPCISDocument", "EPCISDocument");
                    xdoc.AppendChild(xroot);
                    xroot.SetAttribute("xmlns:epcis", "urn:epcglobal:epcis:xsd:1");
                    xroot.SetAttribute("xmlns:xsi", "http://www.w3.org/2001/XMLSchema-instance");
                    xroot.SetAttribute("creationDate", DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss.fffzzzz"));
                    xroot.SetAttribute("schemaVersion", "1.0");

                    XmlElement xn1 = xdoc.CreateElement("EPCISBody");
                    xroot.AppendChild(xn1);

                    XmlElement xn2 = xdoc.CreateElement("EventList");
                    xn1.AppendChild(xn2);

                    XmlElement xn3 = xdoc.CreateElement("ObjectEvent");
                    xn2.AppendChild(xn3);

                    //Append to AGevent (xn3);
                    XmlElement xn4 = xdoc.CreateElement("eventTime");
                    xn3.AppendChild(xn4);
                    XmlText xn4T = xdoc.CreateTextNode(DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ssZ"));
                    xn4.AppendChild(xn4T);

                    XmlElement xn5 = xdoc.CreateElement("eventTimeZoneOffset");
                    xn3.AppendChild(xn5);
                    XmlText xn5T = xdoc.CreateTextNode(DateTime.Now.ToString("zzzz"));
                    xn5.AppendChild(xn5T);

                    XmlElement xn6 = xdoc.CreateElement("epcList");
                    xn3.AppendChild(xn6);
                    XmlElement xn6i = xdoc.CreateElement("epc");
                    xn6.AppendChild(xn6i);
                    XmlText xn6T = xdoc.CreateTextNode("http://wmrfid.org/farm2fork/2000005/product/" + tf + "/" + EPCcode);
                    xn6i.AppendChild(xn6T);

                    XmlElement xn22 = xdoc.CreateElement("action");
                    xn3.AppendChild(xn22);
                    XmlText xn22T = xdoc.CreateTextNode("ADD");
                    xn22.AppendChild(xn22T);

                    XmlElement xn23 = xdoc.CreateElement("bizStep");
                    xn3.AppendChild(xn23);
                    XmlText xn23T = xdoc.CreateTextNode("http://wmrfid.org/farm2fork/2000005/bizstep/picking");
                    xn23.AppendChild(xn23T);

                    XmlElement xn24 = xdoc.CreateElement("disposition");
                    xn3.AppendChild(xn24);
                    XmlText xn24T = xdoc.CreateTextNode("http://wmrfid.org/farm2fork/2000005/disposition/in_progress");
                    xn24.AppendChild(xn24T);

                    XmlElement xn25 = xdoc.CreateElement("readPoint");
                    xn3.AppendChild(xn25);
                    XmlElement xn26 = xdoc.CreateElement("id");
                    xn25.AppendChild(xn26);
                    XmlText xn26T = xdoc.CreateTextNode("http://wmrfid.org/farm2fork/2000005/location/0000030401");   //30401 Sea Cages Reader ---> only one device now
                    xn26.AppendChild(xn26T);

                    XmlElement xn27 = xdoc.CreateElement("bizLocation"); // Tag fixed on the cage
                    xn3.AppendChild(xn27);
                    XmlElement xn28 = xdoc.CreateElement("id");
                    xn27.AppendChild(xn28);
                    XmlText xn28T = xdoc.CreateTextNode("http://wmrfid.org/farm2fork/2000005/location/0000030300"); 
                    xn28.AppendChild(xn28T);


                    xdoc.Save(dirarchiv);

                    dirclass = @"\My Documents\capturas\" + DateTime.Now.ToString("ddMMyy")+".xml";

                    XmlDocument xclass = new XmlDocument();

                    XmlDeclaration xdclass = xclass.CreateXmlDeclaration("1.0", "UTF-8", "no");
                    xclass.AppendChild(xdclass);

                    XmlElement xrootc = xclass.CreateElement("Orden");
                    xclass.AppendChild(xrootc);
                    XmlElement xC1 = xclass.CreateElement("HarvID");
                    xrootc.AppendChild(xC1);
                    XmlText xC1T = xclass.CreateTextNode(pesc.ordenid);
                    xC1.AppendChild(xC1T);
                    XmlElement xC2 = xclass.CreateElement("Cajas");
                    xC1.AppendChild(xC2);
                    XmlText xC2T = xclass.CreateTextNode(pesc.cajas[0]);
                    xC2.AppendChild(xC2T);
                    XmlElement xC3 = xclass.CreateElement("Matricula");
                    xC1.AppendChild(xC3);
                    XmlText xC3T = xclass.CreateTextNode(pesc.matricula);
                    xC3.AppendChild(xC3T);
                    XmlElement xC4 = xclass.CreateElement("Recepcion");
                    xC1.AppendChild(xC4);
                    XmlText xC4T = xclass.CreateTextNode("false");
                    xC4.AppendChild(xC4T);

                    xclass.Save(dirclass);



                    fName = "PES_" + DateTime.Now.ToString("ddMMyyHHmm") + ".xml";
                    flagxml = true;
                }


            }
            catch
            {
                MessageBox.Show("Error al generar el archivo", "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1);
            }
            try //SEND
            {
                string urlString = "http://" + IPenvio.Text + ":8080/epcis-repository-0.5.0/capture";
                HttpWebRequest req = (HttpWebRequest)WebRequest.Create(urlString);

                req.Method = "POST";

                req.AllowWriteStreamBuffering = true;

                // Retrieve request stream and wrap in StreamWriter

                Stream reqStream = req.GetRequestStream();

                StreamWriter wrtr = new StreamWriter(reqStream);



                // Open the local file

                StreamReader rdr = new StreamReader(dirarchiv);

                // loop through the local file reading each line 

                //  and writing to the request stream buffer

                string inLine = rdr.ReadLine();

                while (inLine != null)
                {

                    wrtr.WriteLine(inLine);

                    inLine = rdr.ReadLine();

                }

                rdr.Close();

                wrtr.Close();

                //Comment if you want to keep XML file on mobile

                //File.Delete((System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().GetName().CodeBase)) + "xml.xml");

                req.GetResponse();

                MessageBox.Show("Enviado correctamente", "OK", MessageBoxButtons.OK, MessageBoxIcon.None, MessageBoxDefaultButton.Button1);
            }

            catch (Exception ex)
            {
                MessageBox.Show("Error al enviar el archivo", "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1);
                const string fic = @"\My Documents\capturas\LOGPruebas.txt";
                System.IO.StreamWriter sw = new System.IO.StreamWriter(fic);
                sw.WriteLine(DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss.ffzzzz") + " --> " + ex.Message);
                sw.Close();
            }


        }

        string checkfish(string da)
        {
            string ft = "";
            switch (da)
            {
                case "12":
                    ft = "000112";
                    break;
                case "13":
                    ft = "000113";
                    break;
            }

            return ft;
        }

        string genEPCcode()
        {

            // FOLLOWING V5 SPEC TABLE
            int HH = (Int32.Parse(tagdata.Substring(12)) + 1);


            return tagdata.Substring(2, 10) + HH.ToString(); ;


        }

        private void EscTagComercial_Click(object sender, EventArgs e)
        {
            string tmpStr = tagdata.Substring(0, 2) + EPCcode;    // Only takes the crucial digits 02 o 03 depending on the type of fish
            byte[] value = new byte[8];                                      // Type of fish + BatchID + Batch moving number ---> 12 digitos
            value[7] = 0;

            for (int j = 0; j == 6; j++)
            {
                value[j] = Convert.ToByte(tmpStr.Substring(j * 2, 2), 10);
            }
            int status = Port0.EpcBlockWrite(0, 0, ref value, 4);

            if (status == 0)
            {
                MessageBox.Show("Escritura correcta", "OK", MessageBoxButtons.OK, MessageBoxIcon.Hand, MessageBoxDefaultButton.Button1);
            }
            else
            {
                MessageBox.Show("Error en la escritura", "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1);
            }
        }


    }
}