﻿using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Windows.Forms;
using System.Reflection;
using System.Runtime.InteropServices;

namespace UHF_Demo
{
    class Sound
    {
        private enum PlaySoundFlags : int
        {
            SND_SYNC = 0x0000,  /* play synchronously (default) */
            SND_ASYNC = 0x0001,  /* play asynchronously */
            SND_NODEFAULT = 0x0002,  /* silence (!default) if sound not found */
            SND_MEMORY = 0x0004,  /* pszSound points to a memory file */
            SND_LOOP = 0x0008,  /* loop the sound until next sndPlaySound */
            SND_NOSTOP = 0x0010,  /* don't stop any currently playing sound */
            SND_NOWAIT = 0x00002000, /* don't wait if the driver is busy */
            SND_ALIAS = 0x00010000, /* name is a registry alias */
            SND_ALIAS_ID = 0x00110000, /* alias is a predefined ID */
            SND_FILENAME = 0x00020000, /* name is file name */
            SND_RESOURCE = 0x00040004  /* name is resource name or atom */
        }
#if FULLFRAMEWORK 
	            [DllImport("kernel32")] 
                public static extern bool PlaySound( 
                    string szSound, 
                    IntPtr hMod, 
                    PlaySoundFlags flags 
                    );
#else
        [DllImport("coredll.dll", SetLastError = true)]

        private static extern bool PlaySound(
            string szSound,
            IntPtr hMod,
            PlaySoundFlags flags
            );

#endif
        public static bool PlayWAV(string strFileName)
        {
            bool ret = PlaySound(strFileName, IntPtr.Zero, PlaySoundFlags.SND_FILENAME | PlaySoundFlags.SND_ASYNC);
            return ret;
        }
    }
}
