using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Net.Sockets;
using System.Net;
using System.Xml;
using System.Xml.Serialization;
using System.Xml.Schema;

namespace UHF_Demo
{
    public partial class Engorde : Form
    {
        ComPort Port0 = new ComPort();
        string s0 = "";     
        byte[,] TagBuf = new byte[100, 14];
        bool flagsave;
        int tagindex = 0;     //ARRAY INDEX
        string[] tags = new string[1];       //TAGs ARRAY
        string[] tags2;     //aux array
        bool flagxml = false;
        string fName;
        string EPCcode;
        string tf;
        string dirarchiv;
        string dirclassR;
        string diropc = @"\My Documents\capturas\opciones.xml";
        string IP;

        public Engorde()
        {
            InitializeComponent();
        }

        private void Ant0_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void Pri0_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void Sig0_Click(object sender, EventArgs e)
        {
            tabControl1.SelectedIndex = tabControl1.TabPages.IndexOf(tabPage2);
        }

        private void Ant1_Click(object sender, EventArgs e)
        {
            tabControl1.SelectedIndex = tabControl1.TabPages.IndexOf(tabPage1);
        }

        private void Pri1_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void Sig1_Click(object sender, EventArgs e)
        {
            tabControl1.SelectedIndex = tabControl1.TabPages.IndexOf(tabPage3);
        }

        private void Ant2_Click(object sender, EventArgs e)
        {
            tabControl1.SelectedIndex = tabControl1.TabPages.IndexOf(tabPage2);
        }

        private void Pri2_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void Sig2_Click(object sender, EventArgs e)
        {
            tabControl1.SelectedIndex = tabControl1.TabPages.IndexOf(tabPage4);
        }

        private void Ant3_Click(object sender, EventArgs e)
        {
            tabControl1.SelectedIndex = tabControl1.TabPages.IndexOf(tabPage3);
        }

        private void Pri3_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void Leer_Click(object sender, EventArgs e)
        {
            Port0.ClearIdBuf();     //limpia el buffer de lectura de tags
            tagleidos.Text = "Puerto abierto";
            Port0.Open();           //abre el puerto
            tagleidos.Text = "Timer activado";
            this.timer1.Enabled = true;  //inicia el timer de lectura
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            byte tag_cnt = 0;
            string s1 = "";
            byte TagFlag = 0;
            flagsave = false;

            if (Port0.Opened == true)   //comprueba que este abierto el puerto
            {


                if (Port0.EpcMultiTagIdentify(ref TagBuf, ref tag_cnt, ref TagFlag) == 0)   //si devuelve 0 se habra identificado algun tag
                {
                    tagleidos.Text = "Leyendo";
                    //                    MessageBox.Show(Convert.ToString(tag_cnt));
                    if ((tag_cnt > 0) && (tag_cnt < 200))
                    {
                        for (int TagIndex = 0; TagIndex < tag_cnt; TagIndex++)
                        {
                            s0 = ""; //string.Format("No.{0:D}:", TagCnt + i);
                            for (int CodeIndex = 0; CodeIndex < 12; CodeIndex++)
                            {
                                s1 = string.Format("{0:X2} ", TagBuf[TagIndex, CodeIndex]);
                                s0 += s1;
                            }
                        }

                        for (int i = 0; i < tags.Length; i++)     //checking existence of s0 in tags array
                        {
                            if (tags[i] == s0)
                                flagsave = true;
                        }
                        if (flagsave == false)
                        {
                            Sound.PlayWAV(@"\Application Data\Rfid\wav\shutter.wav");

                            tagindex++;
                            if (tagindex == 1)
                            {
                                tags[0] = s0;
                            }
                            else
                            {
                                tags2 = new string[tagindex];
                                tags.CopyTo(tags2, 0);
                                tags = null;
                                tags2[tagindex - 1] = s0;
                                tags = new string[tagindex];
                                tags2.CopyTo(tags, 0);
                                tags2 = null;

                            }
                            tagleidos.Enabled = true;      //rutina de presentar datos, cerrar el puerto y terminar el timer
                            tagleidos.Text = tags.Length.ToString() + " tags identificados";
                            tagleidos.Enabled = false;
                            Port0.Close();
                            this.timer1.Enabled = false;
                        }



                    }
                }
                else
                {
                    tagleidos.Text = tags.Length.ToString() + " tags identificados";
                    Port0.Close();
                    this.timer1.Enabled = false;

                }

            }
        }

        private void Enviar_Click(object sender, EventArgs e)
        {
                        ///XML FILE GEN.
            try
            {
                if (flagxml == false)
                {
                    

                    EPCcode = genEPCcode();
                    tf = checkfish();
                    

                    dirarchiv = @"\My Documents\capturas\" + "ENG_" + DateTime.Now.ToString("ddMMyyHHmm") + ".xml";
                    XmlDocument xdoc = new XmlDocument();

                    XmlDeclaration xdec = xdoc.CreateXmlDeclaration("1.0", "UTF-8", "no");
                    xdoc.AppendChild(xdec);

                    XmlElement xroot = xdoc.CreateElement("epcis", "EPCISDocument", "EPCISDocument");
                    xdoc.AppendChild(xroot);
                    xroot.SetAttribute("xmlns:epcis", "urn:epcglobal:epcis:xsd:1");
                    xroot.SetAttribute("xmlns:xsi", "http://www.w3.org/2001/XMLSchema-instance");
                    xroot.SetAttribute("creationDate", DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss.fffzzzz"));
                    xroot.SetAttribute("schemaVersion", "1.0");

                    XmlElement xn1 = xdoc.CreateElement("EPCISBody");
                    xroot.AppendChild(xn1);

                    XmlElement xn2 = xdoc.CreateElement("EventList");
                    xn1.AppendChild(xn2);

                    XmlElement xn3 = xdoc.CreateElement("ObjectEvent");
                    xn2.AppendChild(xn3);

                    //Append to AGevent (xn3);
                    XmlElement xn4 = xdoc.CreateElement("eventTime");
                    xn3.AppendChild(xn4);
                    XmlText xn4T = xdoc.CreateTextNode(DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ssZ"));
                    xn4.AppendChild(xn4T);

                    XmlElement xn5 = xdoc.CreateElement("eventTimeZoneOffset");
                    xn3.AppendChild(xn5);
                    XmlText xn5T = xdoc.CreateTextNode(DateTime.Now.ToString("zzzz"));
                    xn5.AppendChild(xn5T);

                    XmlElement xn6 = xdoc.CreateElement("epcList");
                    xn3.AppendChild(xn6);
                    XmlElement xn6i = xdoc.CreateElement("epc");
                    xn6.AppendChild(xn6i);
                    XmlText xn6T = xdoc.CreateTextNode("http://wmrfid.org/farm2fork/2000005/product/" + tf + "/" + EPCcode);
                    xn6i.AppendChild(xn6T);

                    XmlElement xn22 = xdoc.CreateElement("action");
                    xn3.AppendChild(xn22);
                    XmlText xn22T = xdoc.CreateTextNode("ADD");
                    xn22.AppendChild(xn22T);

                    XmlElement xn23 = xdoc.CreateElement("bizStep");
                    xn3.AppendChild(xn23);
                    XmlText xn23T = xdoc.CreateTextNode("http://wmrfid.org/farm2fork/2000005/bizstep/commissioning");
                    xn23.AppendChild(xn23T);

                    XmlElement xn24 = xdoc.CreateElement("disposition");
                    xn3.AppendChild(xn24);
                    XmlText xn24T = xdoc.CreateTextNode("http://wmrfid.org/farm2fork/2000005/disposition/active");
                    xn24.AppendChild(xn24T);

                    XmlElement xn25 = xdoc.CreateElement("readPoint");
                    xn3.AppendChild(xn25);
                    XmlElement xn26 = xdoc.CreateElement("id");
                    xn25.AppendChild(xn26);
                    XmlText xn26T = xdoc.CreateTextNode("http://wmrfid.org/farm2fork/2000005/location/0000030401");   //30401 Sea Cages Reader ---> only one device now
                    xn26.AppendChild(xn26T);

                    XmlElement xn27 = xdoc.CreateElement("bizLocation"); // Tag fixed on the cage
                    xn3.AppendChild(xn27);
                    XmlElement xn28 = xdoc.CreateElement("id");
                    xn27.AppendChild(xn28);
                    XmlText xn28T = xdoc.CreateTextNode(Hex2urn(tags[0])); 
                    xn28.AppendChild(xn28T);




                    xdoc.Save(dirarchiv);       // saving first event file



                    fName = "ENG_" + DateTime.Now.ToString("ddMMyyHHmm") + ".xml";
                    flagxml = true;
                }
            }

            catch
            {
                MessageBox.Show("Error al generar el archivo", "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1);
            }
            try //SEND
            {
                if (System.IO.File.Exists(diropc))
                {
                    XmlDocument docDatosIP = new XmlDocument();
                    //capturar documento XML
                    docDatosIP.Load(diropc);
                    //busqueda lista de nodos
                    XmlNode nodeIP;
                    nodeIP = docDatosIP.DocumentElement;
                    XmlNode nodeex = nodeIP.SelectSingleNode("/Opciones/IPenvio");
                    IP = nodeex.InnerText;
                    docDatosIP.Save(diropc);


                    string urlString = "http://" + IP + ":8080/epcis-repository-0.5.0/capture";
                    HttpWebRequest req = (HttpWebRequest)WebRequest.Create(urlString);

                    req.Method = "POST";

                    req.AllowWriteStreamBuffering = true;

                    // Retrieve request stream and wrap in StreamWriter

                    Stream reqStream = req.GetRequestStream();

                    StreamWriter wrtr = new StreamWriter(reqStream);



                    // Open the local file

                    StreamReader rdr = new StreamReader(dirarchiv);

                    // loop through the local file reading each line 

                    //  and writing to the request stream buffer

                    string inLine = rdr.ReadLine();

                    while (inLine != null)
                    {

                        wrtr.WriteLine(inLine);

                        inLine = rdr.ReadLine();

                    }

                    rdr.Close();

                    wrtr.Close();

                    //Comment if you want to keep XML file on mobile

                    //File.Delete((System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().GetName().CodeBase)) + "xml.xml");

                    Object obj = req.GetResponse();

                    MessageBox.Show("Enviado correctamente", "OK", MessageBoxButtons.OK, MessageBoxIcon.None, MessageBoxDefaultButton.Button1);
                    if (obj != null)
                        File.Delete(dirarchiv);
                }
                else
                {
                    MessageBox.Show("Falta IP de envo", "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1);
                }
            }

            catch (Exception ex)
            {
                MessageBox.Show("Error al enviar el archivo", "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1);
                const string fic = @"\My Documents\capturas\LOGPruebas.txt";
                System.IO.StreamWriter sw = new System.IO.StreamWriter(fic);
                sw.WriteLine(DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss.ffzzzz") + " --> " + ex.Message);
                sw.Close();

                //xml direcciones de archivos a reenviar
                dirclassR = @"\My Documents\capturas\" + DateTime.Now.ToString("ddMMyy") + "R.xml";

                if (System.IO.File.Exists(dirclassR))
                {
                    XmlDocument docDatos = new XmlDocument();
                    //capturar documento XML
                    docDatos.Load(dirclassR);
                    XmlElement union = docDatos.DocumentElement;
                    XmlElement xrootc = docDatos.CreateElement("Ruta");
                    union.AppendChild(xrootc);
                    XmlText xC1T = docDatos.CreateTextNode(dirarchiv);
                    xrootc.AppendChild(xC1T);
                    docDatos.Save(dirclassR);

                }
                else
                {

                    XmlDocument xclass = new XmlDocument();

                    XmlDeclaration xdclass = xclass.CreateXmlDeclaration("1.0", "UTF-8", "no");
                    xclass.AppendChild(xdclass);
                    XmlElement xrootb = xclass.CreateElement("Archivos");
                    xclass.AppendChild(xrootb);
                    XmlElement xC1 = xclass.CreateElement("Ruta");
                    xrootb.AppendChild(xC1);
                    XmlText xC1T = xclass.CreateTextNode(dirarchiv);
                    xC1.AppendChild(xC1T);
                    xclass.Save(dirclassR);
                }
            }
        }

        string checkfish()
        {
            string ft = "";
            switch (tipopez.Text)
            {
                case "Lubina":
                    ft = "000003";
                    break;
                case "Dorada":
                    ft = "000002";
                    break;
            }

            return ft;
        }

        string genEPCcode()
        {

            // FOLLOWING V5 SPEC TABLE

            return Loteorigen.Text.PadLeft(4, '0') + Lotegranja.Text.PadLeft(4, '0');


        }

        //EPC-->URN  ####MODIFIED TO SATISFY THIS TAB####
        private string Hex2urn(string sHexvalue)
        {
            string sValue = null;
            string sTemp;
            string sUrn = "";
            char[] caValue = new char[sHexvalue.Length - 1];

            // REMOVING " " STRING TAGS

            string taux = "";

            for (int i = 0; i < 12; i++)
            {
                taux = taux + sHexvalue.Substring(3 * i, 2);
            }

            ///////////////////////////////////////////



            caValue = taux.ToCharArray();

            foreach (char a in caValue)
            {
                sTemp = Convert.ToString(Convert.ToInt32(a.ToString(), 16), 2);
                sTemp = sTemp.PadLeft(4, '0');
                sUrn = sUrn + sTemp;
            }
            //for SGTIN
            if (sUrn.StartsWith("00110000"))
            {
                int[] c = GetPartition(sUrn.Substring(11, 3));
                long lFilter = Convert.ToInt64(sUrn.Substring(8, 3), 2);
                long lCompany = Convert.ToInt64(sUrn.Substring(14, c[0]), 2);
                //long lCompany = 2000005;
                long lObject = Convert.ToInt64(sUrn.Substring(14 + c[0], c[1]), 2);
                long lSerial = Convert.ToInt64(sUrn.Substring(58), 2);
                sValue = "http://wmrfid.org/farm2fork/" + Convert.ToString(lCompany) + "/product/" + Convert.ToString(lObject).PadLeft(6, '0') + "/" + Convert.ToString(lSerial);
            }
            //GRAI
            else if (sUrn.StartsWith("00110011"))
            {
                int[] c = GetPartition(sUrn.Substring(11, 3));
                long lFilter = Convert.ToInt64(sUrn.Substring(8, 3), 2);
                long lCompany = Convert.ToInt64(sUrn.Substring(14, c[0]), 2);
                // long lCompany = 2000005;
                long lAsset = Convert.ToInt64(sUrn.Substring(14 + c[0], c[1]), 2);
                long lSerial = Convert.ToInt64(sUrn.Substring(58), 2);
                sValue = "http://wmrfid.org/farm2fork/" + Convert.ToString(lCompany) + "/asset/" + Convert.ToString(lAsset).PadLeft(5, '0') + "/" + Convert.ToString(lSerial);

            }
            //for GID
            //else
            //{
            //    long lCompany = Convert.ToInt64(sUrn.Substring(8, 28), 2);
            //    long lObject = Convert.ToInt64(sUrn.Substring(36, 24), 2);
            //    long lSerial = Convert.ToInt64(sUrn.Substring(60), 2);
            //    string sValue = "urn:epc:id:gid:" + Convert.ToString(lCompany) + "." + Convert.ToString(lObject) + "." + Convert.ToString(lSerial);
            //    return sValue;

            //}
            //SGLN
            else if (sUrn.StartsWith("00110010"))
            {
                int[] c = GetPartition(sUrn.Substring(11, 3));
                long lFilter = Convert.ToInt64(sUrn.Substring(8, 3), 2);
                long lCompany = Convert.ToInt64(sUrn.Substring(14, 24), 2);
                // long lCompany = 2000005;
                long lLocation = Convert.ToInt64(sUrn.Substring(14 + 24, 17), 2);
                long lExtension = Convert.ToInt64(sUrn.Substring(58), 2);
                sValue = "http://wmrfid.org/farm2fork/" + Convert.ToString(lCompany) + "/location/" + Convert.ToString(lLocation).PadLeft(5, '0') + "/" + Convert.ToString(lExtension);

            }
            return sValue;
        }

        private int[] GetPartition(string sPartition)
        {
            int[] iaPartitionIndex = new int[2];
            if (sPartition.Equals("000"))
            {
                iaPartitionIndex[0] = 40; iaPartitionIndex[1] = 4;
            }
            else if (sPartition.Equals("001"))
            {
                iaPartitionIndex[0] = 37; iaPartitionIndex[1] = 7;
            }
            else if (sPartition.Equals("010"))
            {
                iaPartitionIndex[0] = 34; iaPartitionIndex[1] = 10;
            }
            else if (sPartition.Equals("011"))
            {
                iaPartitionIndex[0] = 30; iaPartitionIndex[1] = 14;
            }
            else if (sPartition.Equals("100"))
            {
                iaPartitionIndex[0] = 27; iaPartitionIndex[1] = 17;
            }
            else if (sPartition.Equals("101"))
            {
                iaPartitionIndex[0] = 24; iaPartitionIndex[1] = 20;
            }
            else
            {
                iaPartitionIndex[0] = 20; iaPartitionIndex[1] = 24;
            }

            return iaPartitionIndex;
        }

        private void Escribir_Click(object sender, EventArgs e)
        {
            
            //int count = 1;
            

            /* provisional*/
            //byte[] select1 = new byte [2];
            //byte[] select2 = new byte [2];
            //byte[] select3 = new byte [2];
            /*            */
                // Only takes the crucial digits 02 o 03 depending on the type of fish
            //ushort[] value = new ushort[3];                                      // Type of fish + BatchID + Batch moving number ---> 12 digitos
            //short [] wr1= new short [tmpStr.Length/4];
            //label5.Text = tmpStr;
            //for (int j = 0; j<tmpStr.Length/4; j++)
            //{
            //    wr1[j] = Convert.ToInt16(tmpStr.Substring(j * 4, 4), 16);
            //}

            //for (int j = 0; j == 2; j++)
            //{
            //    value[j] = Convert.ToUInt16(tmpStr.Substring(j * 4, 4), 16);
            //}
            /*provisional*/
            //select1[0]=value[0];
            //select1[1]=value[1];
            //select2[0]=value[2];
            //select2[1]=value[3];
            //select3[0]=value[4];
            //select3[0]=value[5];

            //status=Port0.EpcBlockWrite(0, 0, ref select1, 1);
            //if (status==0)
            //    count=1;
            //status=Port0.EpcBlockWrite(0, 1, ref select2, 1);
            //if (status == 0)
            //    count = 2;
            //status = Port0.EpcBlockWrite(0, 2, ref select2, 1);
            //if (status == 0)
            //    count = 3;

            //for (int i = 0; i < wr1.Length; i++)
            //{
            //    count += Port0.EpcWrite((byte)0, (byte)i, (ushort)wr1[i]);
            //}
            //byte mb = (byte)(membank.SelectedIndex);


            Port0.ClearIdBuf();
            Port0.Open();
            this.timer2.Enabled = true;
 

            

            
            //byte pointer = (byte)(puntero.SelectedIndex);
            //ushort data = Convert.ToUInt16(Loteorigen.Text, 16);



            //for (int i = 0; i < value.Length; i++)
            //{
            //    Port0.ClearIdBuf();
            //    Port0.Open();

            //    if (Port0.Opened == true)
            //    {
            //        count = Port0.EpcWrite(mb, (byte)i, value[i]);
            //        label5.Text = "Abierto";
            //    }
            //    Port0.Close();
            //}

            //label5.Text = mb.ToString() + " " + pointer.ToString()+" "+data.ToString();

        }

        private void btnquery_Click(object sender, EventArgs e)
        {
            byte byPower, byFreq,byFreqStart,byFreqStop;
            int status;
            byPower = 0;
            byFreq = 0;
            byFreqStart = 0;
            byFreqStop = 0;
            Port0.ClearIdBuf();
            Port0.Open();
            if (Port0.Opened == true)
                label5.Text = "Abierto";
                status=Port0.GetRf(ref byPower,ref byFreq,ref byFreqStart,ref byFreqStop);
            Port0.Close();
            if (status == 0)
            {
                label5.Text = Convert.ToString(byPower) + " " + Convert.ToString(byFreq);
            }
        }

        private void timer2_Tick(object sender, EventArgs e)
        {
            if (Port0.Opened == true)
            {
                int status = 1;
                string tmpStr = checkfish().Substring(4, 2) + EPCcode + "00";
                byte[] value = new byte[6];                                      // Type of fish + BatchID + Batch moving number ---> 12 digitos
                for (int j = 0; j < 6; j++)
                {
                    value[j] = Convert.ToByte(tmpStr.Substring(j * 2, 2), 16);
                }
                status = Port0.EpcBlockWrite((byte)3, (byte)0, ref value, (byte)3);
                if (status == 0)
                {
                    MessageBox.Show("Escritura correcta", "OK", MessageBoxButtons.OK, MessageBoxIcon.None, MessageBoxDefaultButton.Button1);
                    Port0.Close();
                    this.timer2.Enabled = false;
                }
                else
                {
                    MessageBox.Show("Error en la escritura", "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1);
                    Port0.Close();
                    this.timer2.Enabled = false;
                }
            }

        }
    }
}