using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Net.Sockets;
using System.Net;
using System.Xml;
using System.Xml.Serialization;
using System.Xml.Schema;

namespace UHF_Demo
{
    public partial class Opciones : Form
    {
        string direccionreenvio = @"\My Documents\capturas\" + DateTime.Now.ToString("ddMMyy") + "R.xml";
        string diropc = @"\My Documents\capturas\opciones.xml";
        string IP;

        public Opciones()
        {
            InitializeComponent();
        }

        private void resend_Click(object sender, EventArgs e)
        {
            int good = 0;
            string[] env = null;
            if (System.IO.File.Exists(direccionreenvio) && System.IO.File.Exists(diropc))
            {

                XmlDocument docDatosIP = new XmlDocument();
                //capturar documento XML
                docDatosIP.Load(diropc);
                //busqueda lista de nodos
                XmlNode nodeIP;
                nodeIP = docDatosIP.DocumentElement;
                XmlNode nodeex = nodeIP.SelectSingleNode("/Opciones/IPenvio");
                IP = nodeex.InnerText;
                docDatosIP.Save(diropc);

                XmlDocument docDatos = new XmlDocument();
                //capturar documento XML
                docDatos.Load(direccionreenvio);
                //busqueda lista de nodos
                XmlNode node;
                node = docDatos.DocumentElement;
                XmlNodeList xmlnodeL = node.SelectNodes("/Archivos[Ruta != 'empty']/Ruta");
                if (xmlnodeL.Count != 0)
                {
                    env = new string[xmlnodeL.Count];
                    int i = 0;

                    foreach (XmlNode nod in xmlnodeL)
                    {

                        try
                        {
                            string urlString = "http://" + IP + ":8080/epcis-repository-0.5.0/capture";
                            HttpWebRequest req = (HttpWebRequest)WebRequest.Create(urlString);

                            req.Method = "POST";

                            req.AllowWriteStreamBuffering = true;

                            // Retrieve request stream and wrap in StreamWriter

                            Stream reqStream = req.GetRequestStream();

                            StreamWriter wrtr = new StreamWriter(reqStream);


                            // Open the local file

                            StreamReader rdr = new StreamReader(nod.InnerText);

                            // loop through the local file reading each line 

                            //  and writing to the request stream buffer

                            string inLine = rdr.ReadLine();

                            while (inLine != null)
                            {

                                wrtr.WriteLine(inLine);

                                inLine = rdr.ReadLine();

                            }

                            rdr.Close();

                            wrtr.Close();

                            //Comment if you want to keep XML file on mobile

                            //File.Delete((System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().GetName().CodeBase)) + "xml.xml");

                            Object obj = req.GetResponse();




                            //MessageBox.Show("Enviado correctamente", "OK", MessageBoxButtons.OK, MessageBoxIcon.None, MessageBoxDefaultButton.Button1);
                            if (obj != null)
                            {
                                File.Delete(nod.InnerText);
                                env[i] = nod.InnerText;
                                i++;
                                nod.InnerText = "empty";
                                good = good + 1;

                            }

                        }

                        catch (Exception ex)
                        {


                            MessageBox.Show("Error al enviar el archivo", "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1);
                            const string fic = @"\My Documents\capturas\LOGPruebasR.txt";
                            System.IO.StreamWriter sw = new System.IO.StreamWriter(fic);
                            sw.WriteLine(DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss.ffzzzz") + " --> " + ex.Message);
                            sw.Close();
                        }
                    }
                }

                try
                {

                    MessageBox.Show("Enviados " + good.ToString() + " de " + xmlnodeL.Count.ToString(), "OK", MessageBoxButtons.OK, MessageBoxIcon.None, MessageBoxDefaultButton.Button1);

                    foreach (XmlNode node1 in node.ChildNodes)
                    {
                        for (int j = 0; j < env.Length; j++)
                        {
                            if (node.InnerText != "empty" && node1.InnerText == env[j])
                            {
                                node1.InnerText = "empty";
                            }

                        }
                    }
                    docDatos.Save(direccionreenvio);
                }

                catch (Exception ex)
                {
                    MessageBox.Show("Error al actualizar el archivo", "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1);
                    const string fic = @"\My Documents\capturas\LOGPruebasR-ACT.txt";
                    System.IO.StreamWriter sw = new System.IO.StreamWriter(fic);
                    sw.WriteLine(DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss.ffzzzz") + " --> " + ex.Message);
                    sw.Close();
                }

            }

            else
            {
                MessageBox.Show("Nada que reenviar o sin IP", "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1);
            }
        }

        private void savebtn_Click(object sender, EventArgs e)
        {
            if (System.IO.File.Exists(diropc))
            {
                XmlDocument docDatos = new XmlDocument();
                //capturar documento XML
                docDatos.Load(diropc);
                XmlElement node = docDatos.DocumentElement;
                foreach (XmlNode node1 in node.ChildNodes)
                    node1.InnerText = IPenvio.Text;
                docDatos.Save(diropc);
                MessageBox.Show("IP actualizada", "OK", MessageBoxButtons.OK, MessageBoxIcon.None, MessageBoxDefaultButton.Button1);



            }
            else
            {

                XmlDocument xclass = new XmlDocument();

                XmlDeclaration xdclass = xclass.CreateXmlDeclaration("1.0", "UTF-8", "no");
                xclass.AppendChild(xdclass);
                XmlElement xrootb = xclass.CreateElement("Opciones");
                xclass.AppendChild(xrootb);
                XmlElement xC1 = xclass.CreateElement("IPenvio");
                xrootb.AppendChild(xC1);
                XmlText xC1T = xclass.CreateTextNode(IPenvio.Text);
                xC1.AppendChild(xC1T);
                xclass.Save(diropc);
                MessageBox.Show("IP guardada", "OK", MessageBoxButtons.OK, MessageBoxIcon.None, MessageBoxDefaultButton.Button1);

            }

        }

        private void Pri0_Click(object sender, EventArgs e)
        {
            this.Close();
        }
    }
}