using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Net.Sockets;
using System.Net;
using System.Xml;
using System.Xml.Serialization;
using System.Xml.Schema;

namespace UHF_Demo
{
    public partial class Recepcion : Form
    {
        ComPort Port0 = new ComPort();
        byte[,] TagBuf = new byte[100, 14];
        string[] tags = new string[1];       //TAGs ARRAY
        bool flagxml = false;
        string fName;
        string dirarchiv;
        string dirclassR;
        string diropc = @"\My Documents\capturas\opciones.xml";
        string IP;

        public Recepcion()
        {
            InitializeComponent();
        }

        private void Ant0_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void Pri0_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void Sig0_Click(object sender, EventArgs e)
        {
            tabControl1.SelectedIndex = tabControl1.TabPages.IndexOf(tabPage2);
        }

        private void Ant1_Click(object sender, EventArgs e)
        {
            tabControl1.SelectedIndex = tabControl1.TabPages.IndexOf(tabPage1);
        }

        private void Pri1_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void Envio_Click(object sender, EventArgs e)
        {
            ///XML FILE GEN.
            try
            {
                if (flagxml == false)
                {


                    dirarchiv = @"\My Documents\capturas\" + "REC_" + DateTime.Now.ToString("ddMMyyHHmm") + ".xml";
                    XmlDocument xdoc = new XmlDocument();

                    XmlDeclaration xdec = xdoc.CreateXmlDeclaration("1.0", "UTF-8", "no");
                    xdoc.AppendChild(xdec);

                    XmlElement xroot = xdoc.CreateElement("epcis", "EPCISDocument", "EPCISDocument");
                    xdoc.AppendChild(xroot);
                    xroot.SetAttribute("xmlns:epcis", "urn:epcglobal:epcis:xsd:1");
                    xroot.SetAttribute("xmlns:xsi", "http://www.w3.org/2001/XMLSchema-instance");
                    xroot.SetAttribute("creationDate", DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss.fffzzzz"));
                    xroot.SetAttribute("schemaVersion", "1.0");

                    XmlElement xn1 = xdoc.CreateElement("EPCISBody");
                    xroot.AppendChild(xn1);

                    XmlElement xn2 = xdoc.CreateElement("EventList");
                    xn1.AppendChild(xn2);

                    XmlElement xn3 = xdoc.CreateElement("ObjectEvent");
                    xn2.AppendChild(xn3);

                    //Append to AGevent (xn3);
                    XmlElement xn4 = xdoc.CreateElement("eventTime");
                    xn3.AppendChild(xn4);
                    XmlText xn4T = xdoc.CreateTextNode(DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ssZ"));
                    xn4.AppendChild(xn4T);

                    XmlElement xn5 = xdoc.CreateElement("eventTimeZoneOffset");
                    xn3.AppendChild(xn5);
                    XmlText xn5T = xdoc.CreateTextNode(DateTime.Now.ToString("zzzz"));
                    xn5.AppendChild(xn5T);

                    XmlElement xn6 = xdoc.CreateElement("epcList");
                    xn3.AppendChild(xn6);
                    XmlElement xn6i = xdoc.CreateElement("epc");
                    xn6.AppendChild(xn6i);
                    XmlText xn6T = xdoc.CreateTextNode("http://wmrfid.org/farm2fork/2000005/asset/00001/" + Matricula.Text);
                    xn6i.AppendChild(xn6T);

                    XmlElement xn22 = xdoc.CreateElement("action");
                    xn3.AppendChild(xn22);
                    XmlText xn22T = xdoc.CreateTextNode("OBSERVE");
                    xn22.AppendChild(xn22T);

                    XmlElement xn23 = xdoc.CreateElement("bizStep");
                    xn3.AppendChild(xn23);
                    XmlText xn23T = xdoc.CreateTextNode("http://wmrfid.org/farm2fork/2000005/bizstep/arriving");
                    xn23.AppendChild(xn23T);

                    XmlElement xn24 = xdoc.CreateElement("disposition");
                    xn3.AppendChild(xn24);
                    XmlText xn24T = xdoc.CreateTextNode("http://wmrfid.org/farm2fork/2000005/disposition/in_progress");
                    xn24.AppendChild(xn24T);

                    XmlElement xn25 = xdoc.CreateElement("readPoint");
                    xn3.AppendChild(xn25);
                    XmlElement xn26 = xdoc.CreateElement("id");
                    xn25.AppendChild(xn26);
                    XmlText xn26T = xdoc.CreateTextNode("http://wmrfid.org/farm2fork/2000005/location/01101");   
                    xn26.AppendChild(xn26T);

                    XmlElement xn27 = xdoc.CreateElement("bizLocation"); 
                    xn3.AppendChild(xn27);
                    XmlElement xn28 = xdoc.CreateElement("id");
                    xn27.AppendChild(xn28);
                    XmlText xn28T = xdoc.CreateTextNode("http://wmrfid.org/farm2fork/2000005/location/01001");
                    xn28.AppendChild(xn28T);




                    xdoc.Save(dirarchiv);



                    fName = "REC_" + DateTime.Now.ToString("ddMMyyHHmm") + ".xml";
                    flagxml = true;
                }


            }
            catch
            {
                MessageBox.Show("Error al generar el archivo", "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1);
            }
            try //SEND
            {

                if (System.IO.File.Exists(diropc))
                {
                    XmlDocument docDatosIP = new XmlDocument();
                    //capturar documento XML
                    docDatosIP.Load(diropc);
                    //busqueda lista de nodos
                    XmlNode nodeIP;
                    nodeIP = docDatosIP.DocumentElement;
                    XmlNode nodeex = nodeIP.SelectSingleNode("/Opciones/IPenvio");
                    IP = nodeex.InnerText;
                    docDatosIP.Save(diropc);


                    string urlString = "http://" + IP + ":8080/epcis-repository-0.5.0/capture";
                    HttpWebRequest req = (HttpWebRequest)WebRequest.Create(urlString);

                    req.Method = "POST";

                    req.AllowWriteStreamBuffering = true;

                    // Retrieve request stream and wrap in StreamWriter

                    Stream reqStream = req.GetRequestStream();

                    StreamWriter wrtr = new StreamWriter(reqStream);



                    // Open the local file

                    StreamReader rdr = new StreamReader(dirarchiv);

                    // loop through the local file reading each line 

                    //  and writing to the request stream buffer

                    string inLine = rdr.ReadLine();

                    while (inLine != null)
                    {

                        wrtr.WriteLine(inLine);

                        inLine = rdr.ReadLine();

                    }

                    rdr.Close();

                    wrtr.Close();

                    //Comment if you want to keep XML file on mobile

                    //File.Delete((System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().GetName().CodeBase)) + "xml.xml");

                    Object obj = req.GetResponse();

                    MessageBox.Show("Enviado correctamente", "OK", MessageBoxButtons.OK, MessageBoxIcon.None, MessageBoxDefaultButton.Button1);
                    if (obj != null)
                        File.Delete(dirarchiv);
                }
                else
                {
                    MessageBox.Show("Falta IP de envo", "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1);
                }
            }

            catch (Exception ex)
            {
                MessageBox.Show("Error al enviar el archivo", "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1);
                const string fic = @"\My Documents\capturas\LOGPruebas.txt";
                System.IO.StreamWriter sw = new System.IO.StreamWriter(fic);
                sw.WriteLine(DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss.ffzzzz") + " --> " + ex.Message);
                sw.Close();

                //xml direcciones de archivos a reenviar
                dirclassR = @"\My Documents\capturas\" + DateTime.Now.ToString("ddMMyy") + "R.xml";

                if (System.IO.File.Exists(dirclassR))
                {
                    XmlDocument docDatos = new XmlDocument();
                    //capturar documento XML
                    docDatos.Load(dirclassR);
                    XmlElement union = docDatos.DocumentElement;
                    XmlElement xrootc = docDatos.CreateElement("Ruta");
                    union.AppendChild(xrootc);
                    XmlText xC1T = docDatos.CreateTextNode(dirarchiv);
                    xrootc.AppendChild(xC1T);
                    docDatos.Save(dirclassR);

                }
                else
                {

                    XmlDocument xclass = new XmlDocument();

                    XmlDeclaration xdclass = xclass.CreateXmlDeclaration("1.0", "UTF-8", "no");
                    xclass.AppendChild(xdclass);
                    XmlElement xrootb = xclass.CreateElement("Archivos");
                    xclass.AppendChild(xrootb);
                    XmlElement xC1 = xclass.CreateElement("Ruta");
                    xrootb.AppendChild(xC1);
                    XmlText xC1T = xclass.CreateTextNode(dirarchiv);
                    xC1.AppendChild(xC1T);
                    xclass.Save(dirclassR);
                }
            }
        }
    }
}